Index: /trunk/src/world_entities/player.cc
===================================================================
--- /trunk/src/world_entities/player.cc	(revision 5749)
+++ /trunk/src/world_entities/player.cc	(revision 5750)
@@ -28,4 +28,5 @@
 #include "weapons/test_gun.h"
 #include "weapons/turret.h"
+#include "weapons/cannon.h"
 
 #include "list.h"
@@ -37,5 +38,5 @@
 using namespace std;
 
-CREATE_FACTORY(Player);
+CREATE_FACTORY(Player, CL_PLAYER);
 
 /**
@@ -46,13 +47,4 @@
 {
   this->init();
-
-  //weapons:
-  Weapon* wpRight = new TestGun(this->weaponMan, 0);
-  Weapon* wpLeft = new TestGun(this->weaponMan, 1);
-
-  this->weaponMan->addWeapon(wpRight);
-//  this->weaponMan->addWeapon(wpLeft, WM_CONFIG1, WM_SLOT1);
-//  this->weaponMan->addWeapon(wpRight, WM_CONFIG2);
-//  this->weaponMan->addWeapon(wpLeft, WM_CONFIG2);
 }
 
@@ -88,11 +80,16 @@
 
   //weapons:
-  Weapon* wpRight = new TestGun(this->weaponMan, 0);
+  Weapon* wpRight = new TestGun(0);
   wpRight->setName("testGun Right");
-  Weapon* wpLeft = new TestGun(this->weaponMan, 1);
+  Weapon* wpLeft = new TestGun(1);
   wpLeft->setName("testGun Left");
+  Weapon* cannon = dynamic_cast<Weapon*>(Factory::getFirst()->fabricate(CL_CANNON));
+
+  cannon->setName("BFG");
 
   this->weaponMan->addWeapon(wpLeft, 1, 0);
   this->weaponMan->addWeapon(wpRight,1 ,1);
+  this->weaponMan->addWeapon(cannon, 0, 6);
+
   //this->weaponMan->addWeapon(turret, 3, 0);
 
@@ -134,5 +131,5 @@
 
   this->weaponMan = new WeaponManager(this);
-  this->weaponMan->setSlotCount(10);
+  this->weaponMan->setSlotCount(7);
 
   this->weaponMan->setSlotPosition(0, Vector(-2.6, .1, -3.0));
@@ -153,13 +150,14 @@
   this->weaponMan->setSlotPosition(5, Vector(-1.5, -.5, -.5));
   this->weaponMan->setSlotDirection(5, Quaternion(+M_PI_4*.5-M_PI, Vector(1,0,0)));
-
-  this->weaponMan->setSlotPosition(6, Vector(-2.0, 0.1, -2.0));
-  this->weaponMan->setSlotPosition(7, Vector(-2.0, 0.1, 2.0));
-
-  this->weaponMan->setSlotPosition(8, Vector(-2.5, -0.3, -2.0));
-  this->weaponMan->setSlotDirection(8, Quaternion(-M_PI, Vector(1,0,0)));
-
-  this->weaponMan->setSlotPosition(9, Vector(-2.5, -0.3, 2.0));
-  this->weaponMan->setSlotDirection(9, Quaternion(+M_PI, Vector(1,0,0)));
+//
+   this->weaponMan->setSlotPosition(6, Vector(-1, 0.0, 0));
+   this->weaponMan->setSlotCapability(6, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+   //
+//   this->weaponMan->setSlotPosition(8, Vector(-2.5, -0.3, -2.0));
+//   this->weaponMan->setSlotDirection(8, Quaternion(-M_PI, Vector(1,0,0)));
+//
+//   this->weaponMan->setSlotPosition(9, Vector(-2.5, -0.3, 2.0));
+//   this->weaponMan->setSlotDirection(9, Quaternion(+M_PI, Vector(1,0,0)));:
+
 }
 
@@ -337,13 +335,34 @@
 }
 
+#include "weapons/aiming_turret.h"
 // FIXME THIS MIGHT BE CONSIDERED EITHER A FEATURE, OR A BUG
 void Player::ADDWEAPON()
 {
-  Weapon* turret1 = new Turret(this->weaponMan);
-  turret1->setName("Turret");
-  turret1->setStateDuration(WS_SHOOTING, (float)rand()/RAND_MAX*.5+.1);
-
-  this->weaponMan->addWeapon(turret1, 2);
-
-  this->weaponMan->changeWeaponConfig(2);
-}
+  Weapon* turret = NULL;
+
+  if ((float)rand()/RAND_MAX < .1)
+  {
+    //if (this->weaponMan->hasFreeSlot(2, WTYPE_TURRET))
+    {
+      turret = new Turret();
+      this->weaponMan->addWeapon(turret, 2);
+      this->weaponMan->changeWeaponConfig(2);
+    }
+  }
+  else
+  {
+    //if (this->weaponMan->hasFreeSlot(3))
+    {
+      turret = new AimingTurret();
+      this->weaponMan->addWeapon(turret, 3);
+
+      this->weaponMan->changeWeaponConfig(3);
+    }
+  }
+
+  if(turret != NULL)
+  {
+    turret->setName("Turret");
+    turret->setStateDuration(WS_SHOOTING, (float)rand()/RAND_MAX*.5+.1);
+  }
+}
Index: /trunk/src/world_entities/power_ups/laser_power_up.cc
===================================================================
--- /trunk/src/world_entities/power_ups/laser_power_up.cc	(revision 5749)
+++ /trunk/src/world_entities/power_ups/laser_power_up.cc	(revision 5750)
@@ -25,5 +25,5 @@
 using namespace std;
 
-CREATE_FACTORY(LaserPowerUp);
+CREATE_FACTORY(LaserPowerUp, CL_LASER_POWER_UP);
 
 LaserPowerUp::LaserPowerUp ()
Index: /trunk/src/world_entities/power_ups/turret_power_up.cc
===================================================================
--- /trunk/src/world_entities/power_ups/turret_power_up.cc	(revision 5749)
+++ /trunk/src/world_entities/power_ups/turret_power_up.cc	(revision 5750)
@@ -25,5 +25,5 @@
 using namespace std;
 
-CREATE_FACTORY(TurretPowerUp);
+CREATE_FACTORY(TurretPowerUp, CL_TURRET_POWER_UP);
 
 TurretPowerUp::TurretPowerUp ()
Index: /trunk/src/world_entities/skybox.cc
===================================================================
--- /trunk/src/world_entities/skybox.cc	(revision 5749)
+++ /trunk/src/world_entities/skybox.cc	(revision 5750)
@@ -25,5 +25,5 @@
 using namespace std;
 
-CREATE_FACTORY(SkyBox);
+CREATE_FACTORY(SkyBox, CL_SKYBOX);
 
 /**
Index: /trunk/src/world_entities/terrain.cc
===================================================================
--- /trunk/src/world_entities/terrain.cc	(revision 5749)
+++ /trunk/src/world_entities/terrain.cc	(revision 5750)
@@ -29,5 +29,5 @@
 using namespace std;
 
-CREATE_FACTORY(Terrain);
+CREATE_FACTORY(Terrain, CL_TERRAIN);
 
 /**
Index: /trunk/src/world_entities/weapons/aim.cc
===================================================================
--- /trunk/src/world_entities/weapons/aim.cc	(revision 5749)
+++ /trunk/src/world_entities/weapons/aim.cc	(revision 5750)
@@ -20,7 +20,11 @@
 #include "load_param.h"
 #include "graphics_engine.h"
-#include "glincl.h"
 #include "state.h"
+#include "list.h"
 #include "material.h"
+#include "t_animation.h"
+#include "text.h"
+
+#include "world_entity.h"
 
 using namespace std;
@@ -30,7 +34,9 @@
  * standart constructor
  */
-Aim::Aim (const TiXmlElement* root)
+Aim::Aim (PNode* source, const TiXmlElement* root)
 {
   this->init();
+
+  this->source = source;
 
   if (root)
@@ -47,4 +53,7 @@
   if (this->material)
     delete this->material;
+
+  if (this->text != NULL)
+    delete this->text;
 }
 
@@ -58,11 +67,23 @@
 
   this->setLayer(E2D_LAYER_TOP);
-  this->setRotationSpeed(5);
+  this->setRotationSpeed(30.0* (float)rand()/RAND_MAX + 10.0);
   this->setSize(GraphicsEngine::getInstance()->getResolutionX()/10.0);
 
-//  this->setBindNode(this);
+  this->setBindNode(this);
   this->material = new Material;
-}
-
+  this->source = NULL;
+
+  this->anim = new tAnimation<Aim>(this, &Aim::setSize);
+  this->anim->setInfinity(ANIM_INF_CONSTANT);
+  this->anim->addKeyFrame(500, .3, ANIM_LINEAR);
+  this->anim->addKeyFrame(100, .2, ANIM_LINEAR);
+  this->anim->addKeyFrame(50, .01, ANIM_LINEAR);
+
+  this->text = new Text();
+  this->text->setParent2D(this);
+  this->text->setRelCoor2D(10, -50);
+  this->text->setParentMode2D(E2D_PARENT_MOVEMENT);
+  this->text->setText("Testing");
+}
 
 void Aim::loadParams(const TiXmlElement* root)
@@ -80,4 +101,27 @@
 }
 
+void Aim::searchTarget(float range)
+{
+  tIterator<WorldEntity>* iterator = State::getWorldEntityList()->getIterator();
+  WorldEntity* entity = iterator->firstElement();
+  while (likely(entity != NULL))
+  {
+    if (entity->isA(CL_NPC) && this->source->getAbsCoor().x < entity->getAbsCoor().x && (this->source->getAbsCoor() - entity->getAbsCoor()).len() < range)
+    {
+      if (this->getParent() != entity)
+      {
+        this->anim->replay();
+        this->setParentSoft(entity, 5);
+      }
+      delete iterator;
+      return;
+    }
+    entity = iterator->nextElement();
+  }
+
+  delete iterator;
+}
+
+
 
 /**
@@ -108,27 +152,33 @@
   this->shiftDir2D(dt * rotationSpeed);
 
-
-  float z = 0.0f;
-  glReadPixels ((int)this->getAbsCoor2D().x,
-                 GraphicsEngine::getInstance()->getResolutionY()-(int)this->getAbsCoor2D().y-1,
-                 1,
-                 1,
-                 GL_DEPTH_COMPONENT,
-                 GL_FLOAT,
-                 &z);
-
-
-  GLdouble objX=.0, objY=.0, objZ=.0;
-  gluUnProject(this->getAbsCoor2D().x,
-               GraphicsEngine::getInstance()->getResolutionY()-this->getAbsCoor2D().y-1,
-               .99,  // z
-               GraphicsEngine::modMat,
-               GraphicsEngine::projMat,
-               GraphicsEngine::viewPort,
-               &objX,
-               &objY,
-               &objZ );
-
-  this->setAbsCoor(objX, objY, objZ);
+  char outputText[100];
+  sprintf(outputText, "%s - distance: %f\n", this->getParent()->getName(), (this->source->getAbsCoor() - this->getAbsCoor()).len());
+  this->text->setText(outputText);
+
+
+  if (this->source->getAbsCoor().x > this->getAbsCoor().x )
+    this->searchTarget(1000);
+//   float z = 0.0f;
+//   glReadPixels ((int)this->getAbsCoor2D().x,
+//                  GraphicsEngine::getInstance()->getResolutionY()-(int)this->getAbsCoor2D().y-1,
+//                  1,
+//                  1,
+//                  GL_DEPTH_COMPONENT,
+//                  GL_FLOAT,
+//                  &z);
+//
+//
+//   GLdouble objX=.0, objY=.0, objZ=.0;
+//   gluUnProject(this->getAbsCoor2D().x,
+//                GraphicsEngine::getInstance()->getResolutionY()-this->getAbsCoor2D().y-1,
+//                .99,  // z
+//                GraphicsEngine::modMat,
+//                GraphicsEngine::projMat,
+//                GraphicsEngine::viewPort,
+//                &objX,
+//                &objY,
+//                &objZ );
+//
+//   this->setAbsCoor(objX, objY, objZ);
 }
 
@@ -138,4 +188,5 @@
 void Aim::draw() const
 {
+
   glPushMatrix();
   glTranslatef(this->getAbsCoor2D().x, this->getAbsCoor2D().y, 0);
Index: /trunk/src/world_entities/weapons/aim.h
===================================================================
--- /trunk/src/world_entities/weapons/aim.h	(revision 5749)
+++ /trunk/src/world_entities/weapons/aim.h	(revision 5750)
@@ -12,12 +12,20 @@
 // FORWARD DECLARATION
 class Model;
+class Text;
 class Material;
 class TiXmlElement;
+template<class T> class tAnimation;
 
 //! An Aim for zooming in on Targets.
+/**
+ * An Aim is a PNode, that is connected, to the Target, it has aquired
+ * The target becomes, if selected its Parent.
+ *
+ * Also the Aim is a Element2D, as it draws a cross onto the Target.
+ */
 class Aim : public PNode, public Element2D {
 
  public:
-  Aim(const TiXmlElement* root = NULL);
+  Aim(PNode* source, const TiXmlElement* root = NULL);
   virtual ~Aim();
 
@@ -25,7 +33,10 @@
   void loadParams(const TiXmlElement* root);
 
+  inline void setSource(PNode* source) { this->source = source; };
+
   inline void selectTarget(PNode* target) { this->setParent(target); };
   inline PNode* getTarget(PNode* target) { return this->getParent(); };
 
+  void searchTarget(float range);
 
   void setSize(float size);
@@ -40,4 +51,9 @@
    Material*        material;             //!< a material for the Aim.
    float            rotationSpeed;        //!< Speed of the Rotation.
+   tAnimation<Aim>* anim;
+
+   PNode*           source;               //!< Where this Shot has come from.
+
+   Text*            text;                 //!< A Text to display onto this Node. (distance to Target)
 };
 
Index: /trunk/src/world_entities/weapons/aiming_turret.cc
===================================================================
--- /trunk/src/world_entities/weapons/aiming_turret.cc	(revision 5750)
+++ /trunk/src/world_entities/weapons/aiming_turret.cc	(revision 5750)
@@ -0,0 +1,175 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Benjamin Grauer
+   co-programmer:
+*/
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WEAPON
+
+#include "aiming_turret.h"
+
+#include "weapon_manager.h"
+#include "aim.h"
+#include "projectile.h"
+
+#include "model.h"
+
+#include "null_parent.h"
+
+#include "animation3d.h"
+#include "sound_engine.h"
+
+#include "factory.h"
+
+CREATE_FACTORY(AimingTurret, CL_AIMING_TURRET);
+
+using namespace std;
+
+
+/**
+ *  standard constructor
+
+   creates a new weapon
+*/
+AimingTurret::AimingTurret ()
+  : Weapon()
+{
+  this->init();
+
+  this->loadModel("models/guns/turret2.obj");
+
+
+  this->setActionSound(WA_SHOOT, "sound/shot1.wav");
+  this->setActionSound(WA_ACTIVATE, "sound/vocals/missiles.wav");
+  this->setActionSound(WA_RELOAD, "sound/vocals/reload.wav");
+}
+
+
+AimingTurret::AimingTurret(const TiXmlElement* root)
+{
+  this->init();
+  this->loadParams(root);
+}
+
+/**
+ *  standard deconstructor
+*/
+AimingTurret::~AimingTurret ()
+{
+  // model will be deleted from WorldEntity-destructor
+//  delete this->target;
+}
+
+void AimingTurret::init()
+{
+  this->setClassID(CL_AIMING_TURRET, "AimingTurret");
+
+  Animation3D* animation1 = this->getAnimation(WS_ACTIVATING, this);
+  Animation3D* animation2 = this->getAnimation(WS_DEACTIVATING, this);
+
+  animation1->addKeyFrame(Vector(0, -.5, 0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_CONSTANT);
+  animation1->addKeyFrame(Vector(0, 0, 0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_CONSTANT);
+  animation2->addKeyFrame(Vector(0, 0, 0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_CONSTANT);
+  animation2->addKeyFrame(Vector(0, -.5, 0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_CONSTANT);
+
+  animation1->setInfinity(ANIM_INF_CONSTANT);
+  animation2->setInfinity(ANIM_INF_CONSTANT);
+
+  this->setStateDuration(WS_SHOOTING, .1);
+  this->setStateDuration(WS_RELOADING, .1);
+  this->setStateDuration(WS_ACTIVATING, .4);
+  this->setStateDuration(WS_DEACTIVATING, .4);
+
+  this->setMaximumEnergy(10000, 50);
+  this->increaseEnergy(100000);
+  //this->minCharge = 2;
+
+  this->setCapability(WTYPE_ALLDIRS | WTYPE_TURRET);
+  this->setProjectileType(CL_ROCKET);
+
+
+  this->setEmissionPoint(1.684, 0.472, 0);
+  //this->getProjectileFactory()->prepare(100);
+
+  this->target = new Aim(this);
+  this->target->setVisibility(false);
+}
+
+void AimingTurret::loadParams(const TiXmlElement* root)
+{
+  static_cast<Weapon*>(this)->loadParams(root);
+
+}
+
+void AimingTurret::activate()
+{
+  this->target->setVisibility(true);
+}
+
+void AimingTurret::deactivate()
+{
+  this->target->setVisibility(false);
+}
+
+void AimingTurret::tick(float dt)
+{
+  Quaternion quat;
+  Vector direction = this->target->getAbsCoor() - this->getAbsCoor();
+
+  direction.normalize();
+
+  if (likely (this->getParent() != NULL))
+    quat = Quaternion(direction, this->getParent()->getAbsDir().apply(Vector(0,1,0))) * Quaternion ( -M_PI_2, Vector(0,1,0)) ;
+  else
+    quat = Quaternion(direction, Vector(0,1,0)) * Quaternion ( -M_PI_2, Vector(0,1,0)) ;
+
+  this->setAbsDirSoft(quat, 5);
+
+  this->target->tick(dt);
+}
+
+void AimingTurret::fire()
+{
+  Projectile* pj = this->getProjectile();
+  if (pj == NULL)
+    return;
+
+    pj->setVelocity(/*this->getVelocity()+*/(this->getAbsDir().apply(Vector(1,0,0))*250.0 + VECTOR_RAND(13)
+            /*target->getAbsCoor() - this->getAbsCoor()*/)*.5);//this->getVelocity());
+
+  pj->setParent(NullParent::getInstance());
+  pj->setAbsCoor(this->getEmissionPoint());
+  pj->setAbsDir(this->getAbsDir());
+  pj->activate();
+  this->target->searchTarget(100);
+}
+
+void AimingTurret::destroy ()
+{}
+
+/**
+ * draws the AimingTurret
+*/
+void AimingTurret::draw () const
+{
+  /* draw gun body */
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+  glTranslatef (this->getAbsCoor ().x,
+                this->getAbsCoor ().y,
+                this->getAbsCoor ().z);
+  Vector tmpRot = this->getAbsDir().getSpacialAxis();
+  glRotatef (this->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
+
+  this->model->draw();
+  glPopMatrix();
+}
+
Index: /trunk/src/world_entities/weapons/aiming_turret.h
===================================================================
--- /trunk/src/world_entities/weapons/aiming_turret.h	(revision 5750)
+++ /trunk/src/world_entities/weapons/aiming_turret.h	(revision 5750)
@@ -0,0 +1,37 @@
+/*!
+ * @file aiming_turret.h
+*/
+
+
+#ifndef _AIMING_TURRET_H
+#define _AIMING_TURRET_H
+
+#include "weapon.h"
+
+/* FORWARD DECLARATION */
+class Aim;
+
+class AimingTurret : public Weapon
+  {
+  public:
+    AimingTurret ();
+    AimingTurret(const TiXmlElement* root);
+    virtual ~AimingTurret ();
+
+    void init();
+    void loadParams(const TiXmlElement* root);
+
+    virtual void activate();
+    virtual void deactivate();
+
+    virtual void tick(float dt);
+    virtual void fire();
+    virtual void destroy();
+
+    virtual void draw() const;
+
+  private:
+    Aim*          target;
+  };
+
+#endif /* _AIMING_TURRET_H */
Index: /trunk/src/world_entities/weapons/bomb.cc
===================================================================
--- /trunk/src/world_entities/weapons/bomb.cc	(revision 5750)
+++ /trunk/src/world_entities/weapons/bomb.cc	(revision 5750)
@@ -0,0 +1,173 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Stefan Lienhard
+   co-programmer: ...
+*/
+
+#include "bomb.h"
+#include "glincl.h"
+#include "state.h"
+#include "list.h"
+#include "model.h"
+#include "vector.h"
+#include "fast_factory.h"
+
+
+#include "particle_engine.h"
+#include "particle_emitter.h"
+#include "particle_system.h"
+
+using namespace std;
+
+CREATE_FAST_FACTORY_STATIC(Bomb, CL_BOMB);
+
+/**
+ * constructs and loads a Bomb from a XML-element
+ * @param root the XML-element to load from
+ */
+Bomb::Bomb(const TiXmlElement* root)
+{
+  this->init();
+  if (root != NULL)
+    this->loadParams(root);
+
+  float modelSize = 1.0;
+  this->loadModel("models/projectiles/RadioActiveBomb.obj", 1.0);
+
+  this->energyMin = 1;
+  this->energyMax = 1;
+  this->remove();
+  this->lifeSpan = 15;
+
+  this->emitter = new ParticleEmitter(Vector(0,1,0), M_2_PI, 100, 5);
+  this->emitter->setParent(this);
+  this->emitter->setSpread(M_PI, M_PI);
+}
+
+
+/**
+ * standard deconstructor
+ */
+Bomb::~Bomb ()
+{
+
+}
+
+
+/**
+ * initializes the Bomb
+ * @todo change this to what you wish
+ */
+void Bomb::init()
+{
+  this->setClassID(CL_BOMB, "Bomb");
+
+  /**
+   * @todo: Write CL_PROTO_WORLD_ENTITY INTO THE src/defs/class_id.h (your own definition)
+   */
+
+}
+
+
+/**
+ * loads a Bomb from a XML-element
+ * @param root the XML-element to load from
+ * @todo make the class Loadable
+ */
+void Bomb::loadParams(const TiXmlElement* root)
+{
+  // all the clases this Entity is directly derived from must be called in this way, to load all settings.
+  static_cast<WorldEntity*>(this)->loadParams(root);
+
+
+  /**
+   * @todo: make the class Loadable
+   */
+}
+
+
+/**
+ * advances the Bomb about time seconds
+ * @param time the Time to step
+ */
+void Bomb::tick(float time)
+{
+  //Vector v = *this->flightDirection * ( this->speed * time * 1000 + 0.1);
+  Vector v = this->velocity * (time);
+  this->shiftCoor(v);
+
+  this->lifeCycle += time/this->lifeSpan;
+  if( this->lifeCycle >= 1.0)
+    {
+      PRINTF(5)("FINALIZE==========================\n");
+      PRINTF(5)("current life cycle is: %f\n", this->lifeCycle);
+      PRINTF(5)("FINALIZE===========================\n");
+
+      this->deactivate();
+    }
+}
+
+/**
+ * draws this worldEntity
+ */
+void Bomb::draw () const
+{
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+  float matrix[4][4];
+
+  /* translate */
+  glTranslatef (this->getAbsCoor ().x,
+                this->getAbsCoor ().y,
+                this->getAbsCoor ().z);
+  /* rotate */
+  this->getAbsDir().matrix(matrix);
+  glMultMatrixf((float*)matrix);
+
+  if (model)
+    model->draw();
+  glPopMatrix();
+}
+
+
+/**
+ *
+ *
+ */
+void Bomb::collidesWith (WorldEntity* entity, const Vector& location)
+{
+	this->detonate();
+}
+
+void Bomb::activate()
+{
+  State::getWorldEntityList()->add(this);
+
+}
+
+void Bomb::deactivate()
+{
+  State::getWorldEntityList()->remove(this);
+  Bomb::fastFactory->kill(this);
+}
+
+void Bomb::detonate()
+{
+  tIterator<WorldEntity>* it = State::getWorldEntityList()->getIterator();
+  WorldEntity* lm = it->firstElement();
+
+  while(lm != NULL)
+  {
+   
+    lm = it->nextElement();
+  }
+}
Index: /trunk/src/world_entities/weapons/bomb.h
===================================================================
--- /trunk/src/world_entities/weapons/bomb.h	(revision 5750)
+++ /trunk/src/world_entities/weapons/bomb.h	(revision 5750)
@@ -0,0 +1,45 @@
+/*!
+ * @file bomb.h
+ * @brief description
+*/
+
+#ifndef _BOMB_H
+#define _BOMB_H
+
+#include "projectile.h"
+class FastFactory;
+class ParticleSystem;
+class ParticleEmitter;
+
+//! A Class to ...
+class Bomb : public Projectile
+{
+
+ public:
+  Bomb(const TiXmlElement* root = NULL);
+  virtual ~Bomb();
+
+  void loadParams(const TiXmlElement* root);
+  void init();
+
+//  virtual void postSpawn ();
+//  virtual void leftWorld ();
+
+
+  virtual void draw() const;
+  virtual void tick(float time);
+  virtual void collidesWith (WorldEntity* entity, const Vector& location);
+  virtual void activate();
+  virtual void detonate();
+  virtual void deactivate();
+
+ private:
+  static FastFactory*               fastFactory;
+  static ParticleSystem*            trailParticles;
+  static ParticleSystem*            explosionParticles;
+
+  ParticleEmitter*                  emitter;
+
+};
+
+#endif /* BOMB */
Index: /trunk/src/world_entities/weapons/cannon.cc
===================================================================
--- /trunk/src/world_entities/weapons/cannon.cc	(revision 5750)
+++ /trunk/src/world_entities/weapons/cannon.cc	(revision 5750)
@@ -0,0 +1,211 @@
+
+
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Patrick Boenzli
+   co-programmer:
+
+
+   @todo: direction in which the projectile flights
+   @todo: a target to set/hit
+*/
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WEAPON
+
+#include "cannon.h"
+
+#include "world_entity.h"
+#include "model.h"
+#include "test_bullet.h"
+#include "weapon_manager.h"
+#include "factory.h"
+
+#include "vector.h"
+#include "list.h"
+#include "animation3d.h"
+#include "sound_engine.h"
+
+#include "null_parent.h"
+
+#include "fast_factory.h"
+
+
+using namespace std;
+
+CREATE_FACTORY(Cannon, CL_CANNON);
+
+/**
+ *  standard constructor
+
+   creates a new weapon
+*/
+Cannon::Cannon ()
+  : Weapon()
+{
+  this->init();
+}
+
+
+Cannon::Cannon(const TiXmlElement* root)
+{
+  this->init();
+  this->loadParams(root);
+}
+
+/**
+ *  standard deconstructor
+*/
+Cannon::~Cannon ()
+{
+  // model will be deleted from WorldEntity-destructor
+}
+
+
+void Cannon::init()
+{
+  this->setClassID(CL_CANNON, "Cannon");
+
+//  this->model = (Model*)ResourceManager::getInstance()->load("models/guns/test_gun.obj", OBJ, RP_CAMPAIGN);
+
+  this->loadModel("models/guns/cannon.obj");
+
+  this->setStateDuration(WS_SHOOTING, 2.0);
+  this->setStateDuration(WS_RELOADING, .1);
+  this->setStateDuration(WS_ACTIVATING, .1);
+  this->setStateDuration(WS_DEACTIVATING, .4);
+
+  this->setMaximumEnergy(100, 1);
+  this->increaseEnergy(30);
+  //this->minCharge = 2;
+
+  this->setActionSound(WA_SHOOT, "sound/shot1.wav");
+
+  this->setCapability(WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
+  this->setProjectileType(CL_BOMB);
+  this->prepareProjectiles(5);
+
+//  this->objectComponent1 = new PNode();
+//  Animation3D* animation1 = this->getAnimation(WS_SHOOTING, this->objectComponent1);
+  Animation3D* animation2 = this->getAnimation(WS_ACTIVATING, this);
+  Animation3D* animation3 = this->getAnimation(WS_DEACTIVATING, this);
+  //parent->addChild(this->objectComponent1, PNODE_ALL);
+//  this->addChild(this->objectComponent1);
+
+//  animation1->setInfinity(ANIM_INF_CONSTANT);
+  animation2->setInfinity(ANIM_INF_CONSTANT);
+  animation3->setInfinity(ANIM_INF_CONSTANT);
+
+  this->setEmissionPoint(3.8, 1.2, 0);
+
+//     animation1->addKeyFrame(Vector(0, -1.5, 0), Quaternion(), 0.1, ANIM_LINEAR, ANIM_NULL);
+//     animation1->addKeyFrame(Vector(0, 0, 0), Quaternion(), 0.1, ANIM_LINEAR, ANIM_NULL);
+//     animation1->addKeyFrame(Vector(0, 0, 0), Quaternion(), 0.0, ANIM_LINEAR, ANIM_NULL);
+
+  animation2->addKeyFrame(Vector(0.0, -1.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
+  animation2->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
+
+  animation3->addKeyFrame(Vector(0.0, 0.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
+  animation3->addKeyFrame(Vector(0.0, -1.0, 0.0), Quaternion(), 0.3, ANIM_LINEAR, ANIM_NULL);
+}
+
+
+void Cannon::loadParams(const TiXmlElement* root)
+{
+
+
+}
+
+
+/**
+ *  this activates the weapon
+
+   This is needed, since there can be more than one weapon on a ship. the
+   activation can be connected with an animation. for example the weapon is
+   been armed out.
+*/
+void Cannon::activate()
+{
+}
+
+
+/**
+ *  this deactivates the weapon
+
+   This is needed, since there can be more than one weapon on a ship. the
+   activation can be connected with an animation. for example the weapon is
+   been armed out.
+*/
+void Cannon::deactivate()
+{
+}
+
+
+/**
+ *  fires the weapon
+
+   this is called from the player.cc, when fire-button is been pushed
+   @todo: the ObjectManager deliveres Projectiles not TestBullets! this should be diffrent
+*/
+void Cannon::fire()
+{
+  Projectile* pj =  this->getProjectile();
+  if (pj == NULL)
+    return;
+
+  pj->setParent(NullParent::getInstance());
+
+  pj->setVelocity(this->getVelocity() + this->getAbsDir().apply(Vector(1,0,0))*15+VECTOR_RAND(5));
+
+  pj->setAbsCoor(this->getEmissionPoint());
+  pj->setAbsDir(this->getAbsDir());
+  pj->activate();
+}
+
+/**
+ *  is called, when the weapon is destroyed
+ *
+ * this is in conjunction with the hit function, so when a weapon is able to get
+ * hit, it can also be destoryed.
+*/
+void Cannon::destroy ()
+{}
+
+/**
+ *  this will draw the weapon
+*/
+void Cannon::draw () const
+{
+  /* draw gun body */
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+  glTranslatef (this->getAbsCoor ().x,
+                this->getAbsCoor ().y,
+                this->getAbsCoor ().z);
+
+  Vector tmpRot = this->getAbsDir().getSpacialAxis();
+  glRotatef (this->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
+
+  this->model->draw();
+  glPopMatrix();
+
+  /* draw objectComponent1: gun coil - animated stuff */
+/*  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+  glTranslatef (this->objectComponent1->getAbsCoor ().x,
+                this->objectComponent1->getAbsCoor ().y,
+                this->objectComponent1->getAbsCoor ().z);
+  tmpRot = this->objectComponent1->getAbsDir().getSpacialAxis();
+  glRotatef (this->objectComponent1->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
+  this->model->draw(0);
+
+  glPopMatrix();*/
+}
+
Index: /trunk/src/world_entities/weapons/cannon.h
===================================================================
--- /trunk/src/world_entities/weapons/cannon.h	(revision 5750)
+++ /trunk/src/world_entities/weapons/cannon.h	(revision 5750)
@@ -0,0 +1,33 @@
+/*!
+ * @file cannon.h
+ * a weapon that is fix on top of the player to fire heavy weaponary.
+*/
+
+
+#ifndef _CANNON_H
+#define _CANNON_H
+
+#include "weapon.h"
+
+class Cannon : public Weapon
+  {
+  public:
+    Cannon ();
+    Cannon (const TiXmlElement* root);
+    virtual ~Cannon ();
+
+    void init();
+    void loadParams(const TiXmlElement* root);
+
+    virtual void activate();
+    virtual void deactivate();
+
+    virtual void fire();
+    virtual void destroy();
+
+    virtual void draw() const;
+
+  private:
+//     PNode* objectComponent1;         //<! the gun is made of multiple parts, these PNodes represent their location and orientation
+  };
+#endif /* _CANNON_H */
Index: /trunk/src/world_entities/weapons/crosshair.cc
===================================================================
--- /trunk/src/world_entities/weapons/crosshair.cc	(revision 5749)
+++ /trunk/src/world_entities/weapons/crosshair.cc	(revision 5750)
@@ -76,4 +76,5 @@
   GraphicsEngine::showMouse(false);
   GraphicsEngine::stealWMEvents(true);
+  SDL_WarpMouse(GraphicsEngine::getInstance()->getResolutionX()/2, GraphicsEngine::getInstance()->getResolutionY()/2);
 }
 
Index: /trunk/src/world_entities/weapons/ground_turret.cc
===================================================================
--- /trunk/src/world_entities/weapons/ground_turret.cc	(revision 5750)
+++ /trunk/src/world_entities/weapons/ground_turret.cc	(revision 5750)
@@ -0,0 +1,140 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Manuel Leuenberger
+   co-programmer: ...
+*/
+
+#include "ground_turret.h"
+#include "factory.h"
+#include "model.h"
+#include "turret.h"
+
+CREATE_FACTORY(GroundTurret, CL_GROUND_TURRET);
+
+using namespace std;
+
+
+/**
+ * constructs and loads a GroundTurret from a XML-element
+ * @param root the XML-element to load from
+ */
+GroundTurret::GroundTurret(const TiXmlElement* root)
+{
+  this->init();
+  if (root != NULL)
+    this->loadParams(root);
+}
+
+
+/**
+ * standard deconstructor
+ */
+GroundTurret::~GroundTurret ()
+{
+
+}
+
+
+/**
+ * initializes the GroundTurret
+ * @todo change this to what you wish
+ */
+void GroundTurret::init()
+{
+  this->setClassID(CL_GROUND_TURRET, "GroundTurret");
+  this->loadModel("models/ground_turret.obj", 5);
+  left = new Turret();
+  left->setParent(this);
+  left->setRelCoor(0,10,0);
+  right = new Turret();
+  right->setParent(this);
+  right->setRelCoor(0,10,0);
+}
+
+
+/**
+ * loads a GroundTurret from a XML-element
+ * @param root the XML-element to load from
+ * @todo make the class Loadable
+ */
+void GroundTurret::loadParams(const TiXmlElement* root)
+{
+  // all the clases this Entity is directly derived from must be called in this way, to load all settings.
+  static_cast<NPC*>(this)->loadParams(root);
+
+
+  /**
+   * @todo: make the class Loadable
+   */
+}
+
+
+/**
+ * advances the GroundTurret about time seconds
+ * @param time the Time to step
+ */
+void GroundTurret::tick(float time)
+{
+
+}
+
+/**
+ * draws this worldEntity
+ */
+void GroundTurret::draw () const
+{
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+  float matrix[4][4];
+
+  /* translate */
+  glTranslatef (this->getAbsCoor ().x,
+                this->getAbsCoor ().y,
+                this->getAbsCoor ().z);
+  /* rotate */
+  this->getAbsDir().matrix(matrix);
+  glMultMatrixf((float*)matrix);
+
+  if (model)
+    model->draw();
+  //left->draw();
+  //right->draw();
+  glPopMatrix();
+}
+
+
+/**
+ *
+ *
+ */
+void GroundTurret::collidesWith (WorldEntity* entity, const Vector& location)
+{
+
+}
+
+/**
+ *
+ *
+ */
+void GroundTurret::postSpawn ()
+{
+    
+}
+
+/**
+ *
+ *
+ */
+void GroundTurret::leftWorld ()
+{
+    
+}
